//These variables will get set automatically
texture tex1;

float2 rcpres;

sampler s0 = sampler_state { texture = <tex1>; };



float4 NormalColourPass( in float2 Tex : TEXCOORD0 ) : COLOR0
{
	float4 color = tex2D( s0, Tex );
	color.a = 1;
	return color;
}

float4 EmbossPass( in float2 Tex : TEXCOORD0 ) : COLOR0
{
	float4 Color = tex2D( s0, Tex );
        Color.a = 1.0f;
        Color.rgb = 0.5f;
        Color -= tex2D( s0, Tex.xy-0.001)*2.0f;
        Color += tex2D( s0, Tex.xy+0.001)*2.0f;
        Color.rgb = (Color.r+Color.g+Color.b)/3.0f;
	return Color;
}




Technique T0
{

    pass p0 { PixelShader = compile ps_2_0 NormalColourPass(); }
    pass p1 { PixelShader = compile ps_2_0 EmbossPass(); }
}

